create extension spitest;

create table big(pk bigint primary key, val float8);
insert into big values (generate_series(1,100000000), random());

create function norm_plpgsql() returns float8 as $$
declare
	result float8 := 0.0;
    x float8;
begin
	for x in select val from big loop
		result := result + x*x;
	end loop;
	return sqrt(result);
end;
$$ language plpgsql;

select sqrt(sum(val*val)) from big;
select norm_spi('select val from big');
select norm_core();
select norm_plpgsql();

create function norm_lua() returns float8 as $$
  local result = 0.0
  for row in server.rows('select val from big') do
    result = result + row.val*row.val
  end
  return math.sqrt(result)
$$ LANGUAGE pllua;

select norm_lua();
